/*****************************************************************************/
/*************************** ZM_VIDEO bridge ************************************/
/** ZM_VIDEO javascript bridge called ZmVideoBridge for the communication between   */
/** zmVideo javascript controller and sdk, and indirectly, with the application*/
/** and the device.
/*****************************************************************************/

(function(){
    /** The zmVideostub object */
    var zmVideostub = {};

    /** 必须无参数。关闭H5界面 */
    zmVideostub.close = function(){};
    /** 必须无参数。页面前进。同步返回true/false */
    zmVideostub.forward = function(){};
    /** 必须无参数。页面后退。同步返回true/false */
    zmVideostub.backward = function(){};
    /** 必须无参数。获取设备参数{} */
    zmVideostub.getDeviceInfo = function(){};
    /** 必须一个参数：1-string-应用包名。应用是否已经安装。 */
    zmVideostub.isAppInstalled = function(){};
    /** 必须两个参数：1-string-应用包名；2-string-目标uri. 优先支持2-目标uri，不可两个参数同时为null */
    zmVideostub.openApp = function(){};
    /** 必须两个参数：1-number-跳转类型；2-JSON-跳转宿主参数。跳转到宿主的指定页面 */
    zmVideostub.toHostApp = function(){};
    /** 必须一个参数：1-string-小应用地址。跳转连信小应用。 */
    zmVideostub.openLightApp = function(){};
    /** 必须一个参数：目标scheme地址。SDK内部跳转 */
    zmVideostub.routeTo = function(){};
    /** 必须一个参数：应用包名。打开应用商店 */
    zmVideostub.jumpMarketStore = function(){};
    //zmVideostub.testCallBack = function(){};

    /** The set of listeners for ZM_VIDEO Native Bridge Events. */
    var listeners = {};
	
    /** Stringify an object. */
    var stringify = zmVideostub.stringify = function(obj) {
    	if (typeof obj === 'object') {
    		var out = [];
    		// for Array
    		if (obj instanceof Array) {
    			for (var p in obj) {
    				out.push(obj[p]);
    			}			
    			return '[' + out.join(',') + ']';
    		} else {
    			// for other object
    			for (var p in obj) {
    				if (typeof obj[p] == 'string') {
    					out.push("'" + p + "': '" + obj[p] + "'");
    				} else {
    					out.push("'" + p + "': " + obj[p]);
    				}
    				
    			}
    			return '{' + out.join(',') + '}';
    		}
    	} else {
    		return String(obj);
    	}
    };
    
    /** Called by the Android SDK when various events occured. */
    zmVideostub.fireEvent = function() {
    	var args = new Array(arguments.length);
    	for (var i = 0, len = arguments.length; i < len; i++) {
    		args[i] = arguments[i];
    	}
    	var event = args.shift();
    	
    	for (var id in listeners[event]) {
    		var handler = listeners[event][id];
        	handler.apply({}, args);
        }
    };

    /**
    * Subscribes a specific handler method to a specific event.
    * 
    * @param event - string, name of event to listen for
    * @param listener - function to execute
    * @returns none
    */
    zmVideostub.addEventListener = function(event, listener) {
    	var handlers = listeners[event];
    	if (handlers == null) {
    		// no handlers defined yet, set it up
    		listeners[event] = [];
    		handlers = listeners[event];
    	}
    	// see if the listener is already present
    	for (var handler in handlers) {
    		if (listener == handler) {
    			// listener already present, nothing to do
    			return;
    		}
    	}
    	// not present yet, go ahead and add it
    	handlers.push(listener);
    };
    
    /**
    * Unsubscribes a specific handler method from a specific event.
    * 
    * @param event - string, name of event to listen for
    * @param listener - function to be removed
    * @returns none 
    */
    zmVideostub.removeEventListener = function(event, listener) {
		var handlers = listeners[event];
		if (handlers != null) {
			var idx = handlers.indexOf(listener);				
			if(idx !== -1) {
				handlers.splice(idx, 1);
			}
		}
    };
    
    var ZmVideoBridge = window.ZmVideoBridge = {
        map: {},
        invokeJSCallback: function(){
            var d = Array.prototype.slice.call(arguments, 0);
            var c = d.shift();
            var e = d.shift();
            this.map[c].apply(this, d);
            delete this.map[c];
        }
    };

    ZmVideoBridge.invokeAndroid = function(){
        var f = Array.prototype.slice.call(arguments, 0);
        var e = [];
        for (var h = 1; h < f.length; h++) {
            var c = f[h];
            var j = typeof c;
            if (j == "object" && c instanceof Array) {
                e[e.length] = "array";
            }
            else if(c == null || j == undefined){
                f[h] = null;
                e[e.length] = "object";
            }
            else {
                e[e.length] = j;
            }
            if (j == "function") {
                var mK = f[0] + "_" + h + "_" + parseInt(Math.random() * 10000);
                ZmVideoBridge.map[mK] = c;
                f[h] = mK
            }
        }
        var methodname = f.shift();
        var exp = JSON.stringify(({
            method: methodname,
            service: 'ZmVideo',
            types: e,
            args: f
        }));
        var g = JSON.parse(prompt(exp));
        if (g.code != 200) {
            throw "ZmVideoBridge call(" + exp + ") error with code:" + g.code + ", message:" + g.result
        }
        console.log(g.result);
        return g.result
    };

    Object.getOwnPropertyNames(zmVideostub).forEach(function(d) {
        var c = zmVideostub[d];
        if (typeof c === "function" && d != "stringify" && d != "fireEvent" && d != "addEventListener" && d != "removeEventListener") {
            zmVideostub[d] = function() {
                return ZmVideoBridge.invokeAndroid.apply(zmVideostub, [d].concat(Array.prototype.slice.call(arguments, 0)))
            }
        }
    });
})();
