function strEndsWith(str, suffix) {
    return str.match(suffix + "$") == suffix;
}

function loadJavascript(path) {
    var scriptElements = document.getElementsByTagName("script");
    for (index in scriptElements) {
        if (scriptElements[index].src !== undefined && strEndsWith(scriptElements[index].src, path)) {
            console.log("duplicate file : " + scriptElements[index].src + " : " + path);
            return;
        }
    }

    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = path;
    document.getElementsByTagName("head")[0].appendChild(script);
}

loadJavascript('/zx_local_res/jssdk/html2canvas.js');
loadJavascript('/zx_local_res/jssdk/cordova.js');

var lmVoice = {
   // 创建房间
    createRoom: function (resultCallback) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "createRoom", []);
    },

    // 加入房间
    joinRoom: function (resultCallback, channelId) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "joinRoom", [channelId]);
    },

    // 开关本地麦克风
    operationUserMicrophone: function (resultCallback, type) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "operationUserMicrophone", [type]);
    },

    // 屏蔽远端麦克风
    shieldUserMicrophone: function (resultCallback, userId, type) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "shieldUserMicrophone", [userId, type]);
    },

    // 用户开关麦位回调
    userMicrophoneNotice: function (resultCallback) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "userMicrophoneNotice", []);
    },

    // 用户说话声音大小回调
    userVoiceNotice: function (resultCallback) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "userVoiceNotice", []);
    },

    // 离开房间
    leaveTalkingRoom: function (resultCallback) {
        cordova.exec(function (result) {
            if (resultCallback != null) {
                resultCallback(result);
            }
        }, function (error) {
            if (resultCallback != null) {
                resultCallback(null);
            }
        }, "LmVoice", "leaveTalkingRoom", []);
    },
};