window.onload = function() {
	const closeBtn = document.querySelector('.close-button');
	const reloadBtn = document.querySelector('.reload-button');

	const currentUrl = decodeURIComponent(window.location.href);
	const urlSplit = currentUrl.split('?');

	const params = {};
	if(urlSplit.length > 1){
		for(let index = 1; index < urlSplit.length; index++){
			const queryParams = urlSplit[index];
			if (queryParams) {
				const keyValues = queryParams.split('&');
				keyValues.forEach(function(keyvalue) {
					const keyvalueArr = keyvalue.split('=');
					params[keyvalueArr[0]] = keyvalueArr[1];
				});
			}
		}
	}

	let errorMsg = '网页加载失败';
	if (params.errorMsg) {
		errorMsg = params.errorMsg;
	}

	const elErrorMsg = document.querySelector('.error-msg');
	elErrorMsg.innerHTML = errorMsg;

	closeBtn.onclick = function() {
		if (window.zx.closeWebView) {
			window.zx.closeWebView(function(data) {
				//TODO:
			});
		} else {
			window.location.href = '/';
		}
	};

	reloadBtn.onclick = function() {
		if (params.reloadUrl) {
			if (window.zx.reloadWebView) {
				window.zx.reloadWebView(params.reloadUrl, function(data) {});
			} else {
				window.location = params.reloadUrl;
			}
		} else {
			throw new Error('未设置重新加载地址');
		}
	};
}
